require "import"
import "android.widget.*"
import "android.view.*"

-- 方向常量
local DIRECTION_NONE = 0
local DIRECTION_LEFT = 1
local DIRECTION_RIGHT = 2
local DIRECTION_UP = 3
local DIRECTION_DOWN = 4

function scscsr()
local txt = edit.text
local s = ""

if not txt or txt == "" then
service.speak("编辑框为空")
return true
end

local gb = edit.getSelectionEnd() or 0
if gb < 0 then gb = 0 end

local n1, n2 = 0, -1
local tbl = {"，","。","：","？","！","……","；",",",".","!","?",";","\n","(",")"}

-- 向左查找分隔符
for n = gb-1, 1, -1 do
if table.find(tbl, utf8.sub(txt, n, n)) then
n1 = n
break
end
end

-- 向右查找分隔符
if gb < utf8.len(txt) then
for n = gb, utf8.len(txt)-1, 1 do
if table.find(tbl, utf8.sub(txt, n, n)) then
n2 = n
break
end
end
end

-- 提取要删除的部分
s = utf8.sub(txt, n1+1, n2)

-- 构建新文本
local newText
if n2 == -1 then
newText = utf8.sub(txt, 1, n1)
else
newText = utf8.sub(txt, 1, n1)..utf8.sub(txt, n2+1, -1)
end

-- 更新文本
edit.text = newText
edit.setSelection(n1)
service.speak(s.."已删除")
return true
end
-- 触摸参数
local startX, startY
local minDistance = 50  -- 滑动最小距离
local maxClickDistance = 20  -- 点击最大允许移动距离(超过则认为是滑动)
local lastDirection = DIRECTION_NONE

-- 滑动检测参数
local isClick = false  -- 标记是否为点击操作
local isSliding = false  -- 标记是否为滑动操作


layout = {
LinearLayout,
{
EditText,
id = "edit",
hint="语音输入面板",
layout_width = "100%w",
layout_height = "100%h",
gravity = "center",
background="#880000ff",
},
}

yymb = LuaDialog()
yymb.setView(loadlayout(layout))
yymb.show()

-- 判断方向
local function getDirection(dx, dy)
if math.abs(dx) > math.abs(dy) then
if dx > minDistance then return DIRECTION_RIGHT end
if dx < -minDistance then return DIRECTION_LEFT end
else
if dy > minDistance then return DIRECTION_DOWN end
if dy < -minDistance then return DIRECTION_UP end
end
return DIRECTION_NONE
end

edit.onTouch = function(v, event)
local action = event.getActionMasked()
local x, y = event.getX(), event.getY()

if action == MotionEvent.ACTION_DOWN then
startX = x
startY = y
isClick = true
isSliding = false
lastDirection = DIRECTION_NONE
end

-- 处理移动事件
if action == MotionEvent.ACTION_MOVE then
local dx = x - startX
local dy = y - startY

-- 如果移动距离超过阈值，则认为是滑动
if math.abs(dx) > maxClickDistance or math.abs(dy) > maxClickDistance then
isClick = false
isSliding = true
end

-- 滑动处理
if isSliding then
local direction = getDirection(dx, dy)
if direction ~= DIRECTION_NONE and direction ~= lastDirection then
-- 单指滑动
if direction == DIRECTION_LEFT then
scscsr()
elseif direction == DIRECTION_RIGHT then
service.execute("语音输入", node)
elseif direction == DIRECTION_UP then
service.execute("返回", node)
service.asyncSpeak("退出")
elseif direction == DIRECTION_DOWN then
yymb.dismiss()
task(500,function()
service.insert(node,edit.text)
end)
end
lastDirection = direction
startX = x
startY = y
end
end
return true
end

-- 处理抬起事件
if action == MotionEvent.ACTION_UP then
return true
end

return true
end
return true